package  fd.explicit;

import  juice.util.JuiceUtil;
import    rsf.vector.*;
import  juice.util.Tester;
import   java.util.Random;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class DiffusionStepOpTest {
  public static void main( String[] args) {

    boolean passed = true;
    Random randy = new Random(1998); 

    int ny = 11; 
    int nx = 10; 
    int nt = 100;
    Rsf ipt = RsfFactory.newRsf(nx,ny,nt);
    Rsf opt = RsfFactory.newRsf(nx,ny,nt);
    Rsf vel = RsfFactory.newRsf(nx,ny); vel.fill(0.125F); 
    Rsf dvl = RsfFactory.newRsf(nx,ny); dvl.rand();
    vel.addScale(0.05F, dvl);

    DiffusionStepOp op = new DiffusionStepOp((RsfSpace) ipt.getSpace(), vel); 

    // Dot product test 
    ipt.rand();
    opt.rand();
    float yax = opt.dot(op          .image(ipt));
    float xay = ipt.dot(op.adjoint().image(opt));
    float eps = Math.abs(yax - xay) / (Math.abs(yax) + Math.abs(xay)); 
    if (eps > 0.00001F) passed = false; 
    System.err.println("Eps is: " + eps); 
    System.err.println("yAx is: " + yax); 
    System.err.println("xAy is: " + xay); 
    Tester.exit(passed);
  }
}

