package  fd.explicit;

import    rsf.vector.*;
import    rsf.util.*; 
import  juice.operator.*;
import    jam.operator.*;
import   java.util.Random;
import    sep.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ImpAbsorbedWave {
  public static void main( String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 
    int nt        = cmd.getInt("nt",150);
    int ny        = cmd.getInt("ny",100);
    int nx        = cmd.getInt("nx", 75);

    Rsf vel = RsfFactory.newRsf(nx,ny); vel.fill((float) Math.sqrt(0.45)); 
    Rsf dvl = RsfFactory.newRsf(nx,ny); dvl.rand(); 
    //vel.addScale(0.05F, dvl);
    Rsf[] med = AbsorbingBoundary.getVelocities(vel);
    for (int i = 0; i < med.length; i++) {
      med[i].write("med" + i + ".H");
    }

    Rsf   opt = RsfFactory.newRsf(nx,ny,nt);
    Rsf   ipt = RsfFactory.newRsf(nx,ny,nt);
    Random randy = new Random(1998); 
    for (int it=0; it < nt; it++) {
      int iy = (int) (randy.nextFloat()*ny); 
      int ix = (int) (randy.nextFloat()*nx);   // random location
      if ( it%15 == 0 && it < nt/2 ) 
	((Rsf3) ipt).d[it][iy][ix] += 1.5555F; // src impulse
    }
    Rsf stupid = Tent.newRsf(3,3,10); 
    stupid.write("stupid.H");
    ipt = Convolver.convolve(Ricker.newRsf(RsfFactory.newRsf(7,7,7)), ipt);

    WaveOpWithAbsorption op = 
      new WaveOpWithAbsorption((RsfSpace) ipt.getSpace(), med); 

    boolean isFwd = cmd.getBoolean("isFwd", true);
    if (isFwd) op          .image(ipt, opt);
    else       op.adjoint().image(ipt, opt);
    opt.write(System.out);
  }
}

