package  fd.explicit;

import    rsf.vector.*;
import    rsf.util.*; 
import  juice.operator.*;
import    jam.operator.*;
import   java.util.Random;
import    sep.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ImpReflectedWave {
  public static void main( String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 
    int nt        = cmd.getInt("nt",150);
    int ny        = cmd.getInt("ny",100);
    int nx        = cmd.getInt("nx", 75);

    Rsf vel = RsfFactory.newRsf(nx,ny); vel.fill(0.45F); 
    Rsf dvl = RsfFactory.newRsf(nx,ny); dvl.rand();
    //vel.addScale(0.05F, dvl);
    Rsf opt = RsfFactory.newRsf(nx,ny,nt);
    Rsf ipt = RsfFactory.newRsf(nx,ny,nt);
    Random randy = new Random(1998); 
    for (int it=0; it < nt; it++) {
      int iy = (int) (randy.nextFloat()*ny); 
      int ix = (int) (randy.nextFloat()*nx);   // random location
      if ( it%15 == 0 && it < nt/2 ) 
	((Rsf3) ipt).d[it][iy][ix] += 1.5555F; // src impulse
    }
    ipt = Convolver.convolve(Ricker.newRsf(RsfFactory.newRsf(7,7,7)), ipt);

    WaveStepOp op = new WaveStepOp((RsfSpace) ipt.getSpace(), vel); 

    boolean isFwd = cmd.getBoolean("isFwd", true);
    if (isFwd) op          .image(ipt, opt);
    else       op.adjoint().image(ipt, opt);
    opt.write(System.out);
  }
}

