package  fd.explicit;

import    rsf.vector.*;
import    rsf.util.*; 
import  juice.operator.*;
import    jam.operator.*;
import   java.util.Random;
import    sep.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ImpulseFlow {
  public static void main( String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 
    int nt        = cmd.getInt("nt",150);
    int ny        = cmd.getInt("ny",100);
    int nx        = cmd.getInt("nx", 75);
    Rsf opt = RsfFactory.newRsf(nx,ny,nt);
    Rsf ipt = RsfFactory.newRsf(nx,ny,nt);

    Rsf prm = RsfFactory.newRsf(nx,ny); prm.fill(0.100F);

    Random randy = new Random(1998); 
    for (int it=0; it < nt; it++) {
      int iy = (int) (randy.nextFloat()*ny); 
      int ix = (int) (randy.nextFloat()*nx);   // random location
      if ( it%15 == 0 && it < nt/2 ) 
	((Rsf3) ipt).d[it][iy][ix] += 1.5555F; // src impulse
    }
    ipt = Convolver.convolve(Tent.newRsf(3,3,10), ipt);

    DiffusionStepOp op = new DiffusionStepOp((RsfSpace) ipt.getSpace(), prm); 

    boolean isFwd = cmd.getBoolean("isFwd", true);
    if (isFwd) op          .image(ipt, opt);
    else       op.adjoint().image(ipt, opt);
    opt.write(System.out);
  }
}

