package  fd.explicit;

import    rsf.vector.*;
import    rsf.util.*; 
import  juice.operator.*;
import    jam.operator.*;
import   java.util.Random;
import    sep.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ReservoirFactory {
  public static void main( String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 
    int ny        = cmd.getInt("ny",100);
    int nx        = cmd.getInt("nx", 75);

    Rsf perm = ReservoirFactory.newRsf(nx,ny);
    perm.write(System.out);
  }

  /** This should be overloaded with other newRsf invocations. */
  static Rsf newRsf(int nx, int ny) {

    int x1 = (int) (    nx / 4);
    int y1 = (int) (    ny / 4);
    int x2 = (int) (3 * nx / 4);
    int y2 = (int) (3 * ny / 4);
    double r0 = 1.05 * Math.sqrt((x1-x2)*(x1-x2) + (y1-y2)*(y1-y2)); 

    Rsf perm = RsfFactory.newRsf(nx,ny); perm.fill(0.005F); 
    float[][] p = ((Rsf2) perm).d;
    for (int iy = 0; iy < ny; iy++) { float dy1 = (iy - y1); dy1 = dy1*dy1;
                                      float dy2 = (iy - y2); dy2 = dy2*dy2;
    for (int ix = 0; ix < nx; ix++) { float dx1 = (ix - x1); dx1 = dx1*dx1;
                                      float dx2 = (ix - x2); dx2 = dx2*dx2;
      double r = Math.sqrt(dy1 + dx1) + Math.sqrt(dy2 + dx2);
      if (r < r0) {
	p[iy][ix] += 0.120F;
      }
    }}
    return perm;
  }
}

