package  fd.explicit;

import    rsf.vector.*;
import    rsf.util.*; 
import  juice.operator.*;
import    jam.operator.*;
import   java.util.Random;
import    sep.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ReservoirFlow {
  public static void main( String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 
    int nt        = cmd.getInt("nt",150);
    int ny        = cmd.getInt("ny",100);
    int nx        = cmd.getInt("nx", 75);
    Rsf opt = RsfFactory.newRsf(nx,ny,nt);
    Rsf ipt = RsfFactory.newRsf(nx,ny,nt);

    Rsf prm = ReservoirFactory.newRsf(nx,ny); 

    int x1 = (int) (nx     /4.); int y1 = (int) (ny     /4.); 
    int x2 = (int) (nx * 3./4.); int y2 = (int) (ny * 3./4.); 
    for (int it=0; it < nt; it++) {
      if ( it > 8 && it < nt ) {
	((Rsf3) ipt).d[it][y1][x1] +=  0.10F; // src impulse
	((Rsf3) ipt).d[it][y2][x2] += -0.15F; // src impulse
      }
    }

    DiffusionStepOp op = new DiffusionStepOp((RsfSpace) ipt.getSpace(), prm); 

    boolean isFwd = cmd.getBoolean("isFwd", true);
    if (isFwd) op          .image(ipt, opt);
    else       op.adjoint().image(ipt, opt);
    opt.write(System.out);
  }
}

