package  fd.explicit;

import    rsf.vector.*;
import    rsf.util.*; 
import  juice.operator.*;
import    jam.operator.*;
import   java.util.Random;
import    sep.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ReservoirWave {
  public static void main( String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 
    int nt        = cmd.getInt("nt",150);
    int ny        = cmd.getInt("ny",100);
    int nx        = cmd.getInt("nx", 75);
    String fname  = cmd.getString("vel");

System.err.println("my name is: " + fname);

    Rsf vel = RsfFactory.newRsf(fname); 
    Rsf[] med = AbsorbingBoundary.getVelocities(vel);
 
    Rsf   opt = RsfFactory.newRsf(nx,ny,nt);
    Rsf   ipt = RsfFactory.newRsf(nx,ny,nt);

    // line source 
    for (int iy=0; iy < ny; iy++) {
      ((Rsf3) ipt).d[10][iy][0] += 1.5555F; // src impulse
    }
    ipt = Convolver.convolve(Ricker.newRsf(RsfFactory.newRsf(7,7,7)), ipt);

    WaveStepOp op = 
      new WaveStepOp((RsfSpace) ipt.getSpace(), vel); 

    boolean isFwd = cmd.getBoolean("isFwd", true);
    if (isFwd) op          .image(ipt, opt);
    else       op.adjoint().image(ipt, opt);
    opt.write(System.out);
  }
}

