package  fd.frog;

import    rsf.vector.*;
import  juice.operator.*;
import    jam.operator.*;
import   java.util.Random;
import    sep.io.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class Frog {
  public static void main( String[] args) {
    ArgumentKeeper cmd = new ArgumentKeeper(args); 
    int nt        = cmd.getInt("nt",150);
    int ny        = cmd.getInt("ny",100);
    int nx        = cmd.getInt("nx", 75);
    /*
    int nt        = cmd.getInt("nt",3);
    int ny        = cmd.getInt("ny",10);
    int nx        = cmd.getInt("nx", 7);
    */

    float visc    = cmd.getFloat("sigma",0.01F);

    boolean isFwd = cmd.getBoolean("isFwd", true);

    Random randy = new Random(1998); 

    Wave grid = new Wave(nt, ny, nx); 
    Rsf2 kappa = (Rsf2) grid.getSpatialGrid().newMember(); 
    Rsf2 dense = (Rsf2) grid.getSpatialGrid().newMember(); 
    Rsf2 sigma = (Rsf2) grid.getSpatialGrid().newMember(); 
    float[][] kap = kappa.getData();
    float[][] rho = dense.getData();
    float[][] sig = sigma.getData();

    float level = 0.01F;
    for (int iy = 0; iy < ny; iy++) {
    for (int ix = 0; ix < nx; ix++) {
      sig[iy][ix] = visc; // + level * randy.nextFloat();
      kap[iy][ix] = .4F + level * (randy.nextFloat() -.5F);
      rho[iy][ix] = .5F + level * (randy.nextFloat() -.5F);
    }}

    hasAdjoint  state = new     StateOp(grid.getFieldGrid(),kappa);
    hasAdjoint motion = new    MotionOp(grid.getFieldGrid(),dense);
    hasAdjoint viscos = new ViscosityOp(grid.getFieldGrid(),sigma);
    CompoundLinOpAdj wave = new CompoundLinOpAdj(state,motion,viscos);

    Rsf3 source = (Rsf3) grid.getFieldGrid().newMember(); 
    Rsf3 wfield = (Rsf3) grid.getFieldGrid().newMember();
    float[][][] src = source.getData();

    for (int it=0; it < nt; it++) {
      int iy = (int) (randy.nextFloat()*ny); 
      int ix = (int) (randy.nextFloat()*nx);          // random location
      if ( it%15 == 0 && it < nt/2 ) 
	src[Wave.P][iy][ix] += 1.5555F;               // throw a pepple
      if (isFwd) wave          .image(source, wfield);
      else       wave.adjoint().image(source, wfield);
      source.copyFrom(wfield); 
    }
    source.write(System.out);
  }
}

