package  fd.frog;

import  juice.util.JuiceUtil;
import    rsf.vector.*;
import  juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class HeatOpTest {
  public static void main( String[] args) {

    boolean passed = true;

    // test Tent values

    // create a wall space
    Axis[] ax = new Axis[2];
    ax[0] = new Axis(100, 2f, 0f, "time", "s" );
    ax[1] = new Axis(100, 2f, 0f, "distance", "m" );

    Rsf2 sigma = (Rsf2)RsfFactory.newRsf(ax);
    float[][] sig = sigma.getData();
    int nt = sigma.getAxis(0).nsamples; 
    int nx = sigma.getAxis(1).nsamples; 
    for (int it = 0; it < nt; it++)
    for (int ix = 0; ix < nx; ix++)
      sig[it][ix] = 0.45F;

    int xmin = (int)(5*nx/8); int tmin =  0;
    int xmax = (int)(6*nx/8); int tmax = nt; 
    for (int it = tmin; it < tmax; it++)
    for (int ix = xmin; ix < xmax; ix++)
      sig[it][ix] = 0.1F;


    Rsf2 source = (Rsf2)RsfFactory.newRsf(ax);
    float[][] src = source.getData();
    xmin = (int)(1*nx/8); tmin = (int)(1*nt/8);
    xmax = (int)(2*nx/8); tmax = (int)(2*nt/8);
    for (int it = tmin; it < tmax; it++)
    for (int ix = xmin; ix < xmax; ix++)
      src[it][ix] = 1.F;

    source.write("source.H"); 

    Rsf2 temper = (Rsf2)RsfFactory.newRsf(ax);

    HeatOp oven = new HeatOp(sigma);

    oven.image(source, temper); 

    temper.write(System.out); 

    // Dot product test 
    source.rand();
    temper.rand();
    float yax = temper.dot(oven          .image(source));
    float xay = source.dot(oven.adjoint().image(temper));
    float eps = Math.abs(yax - xay) / (Math.abs(yax) + Math.abs(xay)); 
    if (eps > 0.00001F) passed = false; 
    System.err.println("Eps is: " + eps); 
    System.err.println("yAx is: " + yax); 
    System.err.println("xAy is: " + xay); 
    Tester.exit(passed);
  }
}

