package  fd.frog;

import  juice.util.JuiceUtil;
import    rsf.vector.*;
import  juice.util.Tester;
import   java.util.Random;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class ViscosityOpTest {
  public static void main( String[] args) {

    boolean passed = true;
    Random randy = new Random(1998); 

    int ny = 11; 
    int nx = 10; 
    Wave grid = new Wave(0, ny,nx);
    Rsf2 kappa = (Rsf2)RsfFactory.newRsf(grid.getSpatialGrid()); 
    float[][] kap = kappa.getData();

    for (int iy = 0; iy < ny; iy++) {
    for (int ix = 0; ix < nx; ix++) {
      kap[iy][ix] = .4F + .01F * randy.nextFloat();
    }}

    Rsf3 source = (Rsf3) RsfFactory.newRsf(grid.getFieldGrid()); 
    Rsf3 wfield = (Rsf3) RsfFactory.newRsf(grid.getFieldGrid()); 

    ViscosityOp op = new ViscosityOp(grid.getFieldGrid(), kappa); 

    // Dot product test 
    source.rand();
    wfield.rand();
    float yax = wfield.dot(op          .image(source));
    float xay = source.dot(op.adjoint().image(wfield));
    float eps = Math.abs(yax - xay) / (Math.abs(yax) + Math.abs(xay)); 
    if (eps > 0.00001F) passed = false; 
    System.err.println("Eps is: " + eps); 
    System.err.println("yAx is: " + yax); 
    System.err.println("xAy is: " + xay); 
    Tester.exit(passed);
  }
}

