package  fd.frog;

import rsf.vector.*;

/**
 * This fixes a few parameters used for the wave field variable. 
 * This may implement a subsurface wave field in the future. Very preliminary. 
 *
 * <BR><!--#include file="./source.inc"--><BR>
 * @author: Matt Schwab (inspired by JFC's frog example)
 */
public class Wave {
  protected static int DIM = 3;
  /** pressure field */
  protected static int P = 0;
  /** velocity field x component */
  protected static int U = 1;
  /** velocity field y component */
  protected static int V = 2; 
  
  public int nt, ny, nx;   

  private Axis[] ax;

  public Wave(int nt, int ny, int nx) {
    this.nt = nt; this.ny = ny; this.nx = nx; 
    ax = new Axis[4];
    ax[0] = new Axis(nx, 1f, 0f, "x distance", "m" );
    ax[1] = new Axis(ny, 1f, 0f, "y distance", "m" );
    ax[2] = new Axis( 3, 1f, 0f, "pressure-velocity-velocity", "m" );
    ax[3] = new Axis(nt, 1f, 0f, "t time", "s" );
  }

  protected RsfSpace getSpatialGrid() {
    Axis[] bx = new Axis[2];
    bx[0] = ax[0];
    bx[1] = ax[1];
    return new RsfSpace(bx); 
  }
  protected RsfSpace getFieldGrid() {
    Axis[] bx = new Axis[3];
    bx[0] = ax[0];
    bx[1] = ax[1];
    bx[2] = ax[2];
    return new RsfSpace(bx); 
  }  
  protected RsfSpace getGrid() {
    return new RsfSpace(ax); 
  }
}




