package  fd.frog;

import  juice.util.JuiceUtil;
import    rsf.vector.*;
import  juice.util.Tester;
import   java.util.Random;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class WaveOpTest {
  public static void main( String[] args) {

    boolean passed = true;
    Random randy = new Random(1998); 

    Wave grid = new Wave(12, 11, 10); 

    Rsf2 kappa = (Rsf2) grid.getSpatialGrid().newMember(); 
    Rsf2 dense = (Rsf2) grid.getSpatialGrid().newMember(); 
    Rsf2 sigma = (Rsf2) grid.getSpatialGrid().newMember(); 
    float[][] kap = kappa.getData();
    float[][] rho = dense.getData();
    float[][] sig = sigma.getData();
    int ny = grid.ny; 
    int nx = grid.nx;

    for (int iy = 0; iy < ny; iy++) {
    for (int ix = 0; ix < nx; ix++) {
      sig[iy][ix] = .2F + .01F * randy.nextFloat();
      kap[iy][ix] = .4F + .01F * randy.nextFloat();
      rho[iy][ix] = .3F + .01F * randy.nextFloat();
    }}

    Rsf4 source = (Rsf4) grid.getGrid().newMember();
    Rsf4 wfield = (Rsf4) grid.getGrid().newMember();

    WaveOp op = new WaveOp(grid, kappa, dense, sigma); 

    // Dot product test 
    source.rand();
    wfield.rand();
    float yax = wfield.dot(op          .image(source));
    float xay = source.dot(op.adjoint().image(wfield));
    float eps = Math.abs(yax - xay) / (Math.abs(yax) + Math.abs(xay)); 
    if (eps > 0.00001F) passed = false; 
    System.err.println("Eps is: " + eps); 
    System.err.println("yAx is: " + yax); 
    System.err.println("xAy is: " + xay); 
    Tester.exit(passed);
  }
}

